import Layout from '@/page/index/'

export default [
  {
    path: '/login',
    name: '登录页',
    component: () =>
      import ( /* webpackChunkName: "page" */ '@/page/login/index'),
    meta: {
      keepAlive: true,
      isTab: false,
      isAuth: false
    }
  }, {
    path: '/homePage',
    name: '首页',
    component: () =>
      import ( /* webpackChunkName: "page" */ '@/views/homePage/index'),
    meta: {
      keepAlive: true,
      isTab: false,
      isAuth: false
    }
  },
  {
    path: '/idp/data/forecastpowerdata',
    component: Layout,
    children: [{
      path: 'index',
      name: '预测数据查询',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/data/forecastpowerdata')
    }],
  },

  {
    path: '/idp/data/windtowerstatusdata',
    component: Layout,
    children: [{
      path: 'index',
      name: '测风塔数据查询',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/data/windtowerstatusdata')
    }],
  },
  {
    path: '/idp/data/windturbinestatusdata',
    component: Layout,
    children: [{
      path: 'index',
      name: '风机数据查询',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/data/windturbinestatusdata')
    }],
  },
  {
    path: '/idp/data/weatherstationstatusdata',
    component: Layout,
    children: [{
      path: 'index',
      name: '气象站数据查询',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/data/weatherstationstatusdata')
    }],
  },

  {
    path: '/idp/data/inverterstatusdata',
    component: Layout,
    children: [{
      path: 'index',
      name: '逆变器数据查询',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/data/inverterstatusdata')
    }],
  },

  {
    path: '/idp/data/accuracyCalculation',
    component: Layout,
    children: [{
      path: 'index',
      name: '准确率查询',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/data/accuracyCalculation')
    }],
  },
  {
    path: '/idp/control/electricfield',
    component: Layout,
    children: [{
      path: 'index',
      name: '场站管理',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/control/electricfield')
    }],
  },
  {
    path: '/idp/control/forecastmanufactor',
    component: Layout,
    children: [{
      path: 'index',
      name: '预测厂家管理',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/control/forecastmanufactor')
    }],
  },
  {
    path: '/idp/control/windtowerinfo',
    component: Layout,
    children: [{
      path: 'index',
      name: '测风塔管理',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/control/windtowerinfo')
    }],
  },
  {
    path: '/idp/control/windturbineinfo',
    component: Layout,
    children: [{
      path: 'index',
      name: '风机管理',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/control/windturbineinfo')
    }],
  },
  {
    path: '/idp/control/weatherstationinfo',
    component: Layout,
    children: [{
      path: 'index',
      name: '气象站管理',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/control/weatherstationinfo')
    }],
  },
  {
    path: '/idp/control/inverterinfo',
    component: Layout,
    children: [{
      path: 'index',
      name: '逆变器管理',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/control/inverterinfo')
    }],
  },
  {
    path: '/idp/control/dqIntervene',
    component: Layout,
    children: [{
      path: 'index',
      name: '人工干预',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/control/dqIntervene')
    }],
  },
  {
    path: '/idp/system/sysUser',
    component: Layout,
    children: [{
      path: 'index',
      name: '用户管理',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/system/sysUser')
    }],
  },
  {
    path: '/idp/system/sysparameter',
    component: Layout,
    children: [{
      path: 'index',
      name: '系统参数',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/system/sysparameter')
    }],
  },
  {
    path: '/an/parsingChannel',
    component: Layout,
    children: [{
      path: 'index',
      name: '解析通道',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/an/parsingChannel')
    }],
  },
  {
    path: '/an/PFParsing',
    component: Layout,
    children: [{
      path: 'index',
      name: '解析配置',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/an/PFParsing')
    }],
  },
  {
    path: '/idp/control/parsingLog',
    component: Layout,
    children: [{
      path: 'index',
      name: '文件解析记录',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/views/idp/control/parsingLog')
    }],
  },
  {
    path: '/404',
    component: () =>
      import ( /* webpackChunkName: "page" */ '@/components/error-page/404'),
    name: '404',
    meta: {
      keepAlive: true,
      isTab: false,
      isAuth: true
    }

  },
  {
    path: '/403',
    component: () =>
      import ( /* webpackChunkName: "page" */ '@/components/error-page/403'),
    name: '403',
    meta: {
      keepAlive: true,
      isTab: false,
      isAuth: false
    }
  },
  {
    path: '/500',
    component: () =>
      import ( /* webpackChunkName: "page" */ '@/components/error-page/500'),
    name: '500',
    meta: {
      keepAlive: true,
      isTab: false,
      isAuth: false
    }
  },
  {
    path: '/',
    name: '主页',
    redirect: '/homePage'
  },
  {
    path: '/myiframe',
    component: Layout,
    redirect: '/myiframe',
    children: [{
      path: ":routerPath",
      name: 'iframe',
      component: () =>
        import ( /* webpackChunkName: "page" */ '@/components/iframe/main'),
      props: true
    }]
  },
  {
    path: '*',
    redirect: '/404',
  },
  {
    path: '/dashboard',
    component: Layout,
    children: [{
      path: 'index',
      name: 'dashboard',
      component: () =>
        import ( /* webpackChunkName: "views" */ '@/page/index/index')
    }],
  },
]
