package com.jiayue.ipp.common.data.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jiayue.ipp.common.data.enums.EquipmentTypeEnum;
import com.jiayue.ipp.common.mybatis.base.BaseDataEntity;
import com.jiayue.ipp.common.mybatis.base.NotLogicBaseEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.validation.constraints.Digits;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.Date;

/**
 * idp_dq_intervene
 *
 * @author whc
 * @date 2022-03-18 15:49:11
 */
@Data
@TableName("idp_dq_intervene")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "idp_dq_intervene")
public class DqIntervene extends NotLogicBaseEntity<DqIntervene> {
    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 预测时间
     */
    private Date forecastTime;

    /**
     * 预测功率（MW）
     */
    @Digits(integer = 10, fraction = 2)
    private BigDecimal activePower;

    /**
     * 场站编号
     */
    private String stationCode;
}
